OGRE: Ogre::Mesh Class Reference - OGRE Documentation

# Ogre::Mesh Class Reference

`#include <OgreMesh.h>`

Inheritance diagram for Ogre::Mesh:

[legend]

List of all members.

## Public Types
typedef std::vector< Real > | LodDistanceList
typedef std::multimap< size_t, VertexBoneAssignment > | VertexBoneAssignmentList
| Multimap of vertex bone assignments (orders by vertex index).
typedef MapIterator < VertexBoneAssignmentList > | BoneAssignmentIterator
typedef std::vector< SubMesh * > | SubMeshList
typedef std::vector< unsigned short > | IndexMap
typedef HashMap< String, ushort > | SubMeshNameMap
| A hashmap used to store optional SubMesh names.
typedef VectorIterator < SubMeshList > | SubMeshIterator
typedef VectorIterator< PoseList > | PoseIterator
typedef ConstVectorIterator < PoseList > | ConstPoseIterator
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
## Public Member Functions
| Mesh (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Default constructor - used by MeshManager.
| ~Mesh ()
SubMesh * | createSubMesh (void)
| Creates a new SubMesh.
SubMesh * | createSubMesh (const String &name)
| Creates a new SubMesh and gives it a name.
void | nameSubMesh (const String &name, ushort index)
| Gives a name to a SubMesh.
ushort | _getSubMeshIndex (const String &name) const
| Gets the index of a submesh with a given name.
unsigned short | getNumSubMeshes (void) const
| Gets the number of sub meshes which comprise this mesh.
SubMesh * | getSubMesh (unsigned short index) const
| Gets a pointer to the submesh indicated by the index.
SubMesh * | getSubMesh (const String &name) const
| Gets a SubMesh by name.
SubMeshIterator | getSubMeshIterator (void)
| Gets an iterator over the available submeshes.
MeshPtr | clone (const String &newName, const String &newGroup=StringUtil::BLANK)
| Makes a copy of this mesh object and gives it a new name.
const AxisAlignedBox & | getBounds (void) const
| Get the axis-aligned bounding box for this mesh.
Real | getBoundingSphereRadius (void) const
| Gets the radius of the bounding sphere surrounding this mesh.
void | _setBounds (const AxisAlignedBox &bounds, bool pad=true)
| Manually set the bounding box for this Mesh.
void | _setBoundingSphereRadius (Real radius)
| Manually set the bounding radius.
void | setSkeletonName (const String &skelName)
| Sets the name of the skeleton this Mesh uses for animation.
bool | hasSkeleton (void) const
| Returns true if this Mesh has a linked Skeleton.
bool | hasVertexAnimation (void) const
| Returns whether or not this mesh has some kind of vertex animation.
const SkeletonPtr & | getSkeleton (void) const
| Gets a pointer to any linked Skeleton.
const String & | getSkeletonName (void) const
| Gets the name of any linked Skeleton.
void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this mesh.
void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this mesh.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh.
void | _notifySkeleton (SkeletonPtr &pSkel)
| Internal notification, used to tell the Mesh which Skeleton to use without loading it.
BoneAssignmentIterator | getBoneAssignmentIterator (void)
| Gets an iterator for access all bone assignments.
const VertexBoneAssignmentList & | getBoneAssignments () const
| Gets a const reference to the list of bone assignments.
void | generateLodLevels (const LodDistanceList &lodDistances, ProgressiveMesh::VertexReductionQuota reductionMethod, Real reductionValue)
| Automatically generates lower level of detail versions of this mesh for use when a simpler version of the model is acceptable for rendering.
ushort | getNumLodLevels (void) const
| Returns the number of levels of detail that this mesh supports.
const MeshLodUsage & | getLodLevel (ushort index) const
| Gets details of the numbered level of detail entry.
void | createManualLodLevel (Real fromDepth, const String &meshName)
| Adds a new manual level-of-detail entry to this Mesh.
void | updateManualLodLevel (ushort index, const String &meshName)
| Changes the alternate mesh to use as a manual LOD at the given index.
ushort | getLodIndex (Real depth) const
| Retrieves the level of detail index for the given depth value.
ushort | getLodIndexSquaredDepth (Real squaredDepth) const
| Retrieves the level of detail index for the given squared depth value.
bool | isLodManual (void) const
| Returns true if this mesh is using manual LOD.
void | _setLodInfo (unsigned short numLevels, bool isManual)
| Internal methods for loading LOD, do not use.
void | _setLodUsage (unsigned short level, MeshLodUsage &usage)
| Internal methods for loading LOD, do not use.
void | _setSubMeshLodFaceList (unsigned short subIdx, unsigned short level, IndexData *facedata)
| Internal methods for loading LOD, do not use.
void | removeLodLevels (void)
| Removes all LOD data from this Mesh.
void | setVertexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the vertex buffers to be used when loading this Mesh.
void | setIndexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the index buffers to be used when loading this Mesh.
HardwareBuffer::Usage | getVertexBufferUsage (void) const
| Gets the usage setting for this meshes vertex buffers.
HardwareBuffer::Usage | getIndexBufferUsage (void) const
| Gets the usage setting for this meshes index buffers.
bool | isVertexBufferShadowed (void) const
| Gets whether or not this meshes vertex buffers are shadowed.
bool | isIndexBufferShadowed (void) const
| Gets whether or not this meshes index buffers are shadowed.
unsigned short | _rationaliseBoneAssignments (size_t vertexCount, VertexBoneAssignmentList &assignments)
| Rationalises the passed in bone assignment list.
void | _compileBoneAssignments (void)
| Internal method, be called once to compile bone assignments into geometry buffer.
void | _updateCompiledBoneAssignments (void)
| Internal method, be called once to update the compiled bone assignments.
void | buildTangentVectors (VertexElementSemantic targetSemantic=VES_TANGENT, unsigned short sourceTexCoordSet=0, unsigned short index=0, bool splitMirrored=false, bool splitRotated=false, bool storeParityInW=false)
| This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.
bool | suggestTangentVectorBuildParams (VertexElementSemantic targetSemantic, unsigned short &outSourceCoordSet, unsigned short &outIndex)
| Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents.
void | buildEdgeList (void)
| Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.
void | freeEdgeList (void)
| Destroys and frees the edge lists this mesh has built.
void | prepareForShadowVolume (void)
| This method prepares the mesh for generating a renderable shadow volume.
EdgeData * | getEdgeList (unsigned int lodIndex=0)
| Return the edge list for this mesh, building it if required.
const EdgeData * | getEdgeList (unsigned int lodIndex=0) const
| Return the edge list for this mesh, building it if required.
bool | isPreparedForShadowVolumes (void) const
| Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.
bool | isEdgeListBuilt (void) const
| Returns whether this mesh has an attached edge list.
const SubMeshNameMap & | getSubMeshNameMap (void) const
| Gets a reference to the optional name assignments of the SubMeshes.
void | setAutoBuildEdgeLists (bool autobuild)
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
bool | getAutoBuildEdgeLists (void) const
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
virtual VertexAnimationType | getSharedVertexDataAnimationType (void) const
| Gets the type of vertex animation the shared vertex data of this mesh supports.
virtual Animation * | createAnimation (const String &name, Real length)
| Creates a new Animation object for vertex animating this mesh.
virtual Animation * | getAnimation (const String &name) const
| Returns the named vertex Animation object.
virtual Animation * | _getAnimationImpl (const String &name) const
| Internal access to the named vertex Animation object - returns null if it does not exist.
virtual bool | hasAnimation (const String &name)
| Returns whether this mesh contains the named vertex animation.
virtual void | removeAnimation (const String &name)
| Removes vertex Animation from this mesh.
virtual unsigned short | getNumAnimations (void) const
| Gets the number of morph animations in this mesh.
virtual Animation * | getAnimation (unsigned short index) const
| Gets a single morph animation by index.
virtual void | removeAllAnimations (void)
| Removes all morph Animations from this mesh.
VertexData * | getVertexDataByTrackHandle (unsigned short handle)
| Gets a pointer to a vertex data element based on a morph animation track handle.
void | updateMaterialForAllSubMeshes (void)
| Iterates through all submeshes and requests them to apply their texture aliases to the material they use.
void | _determineAnimationTypes (void) const
| Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).
bool | _getAnimationTypesDirty (void) const
| Are the derived animation types out of date?
Pose * | createPose (ushort target, const String &name=StringUtil::BLANK)
| Create a new Pose for this mesh or one of its submeshes.
size_t | getPoseCount (void) const
| Get the number of poses.
Pose * | getPose (ushort index)
| Retrieve an existing Pose by index.
Pose * | getPose (const String &name)
| Retrieve an existing Pose by name.
void | removePose (ushort index)
| Destroy a pose by index.
void | removePose (const String &name)
| Destroy a pose by name.
void | removeAllPoses (void)
| Destroy all poses.
PoseIterator | getPoseIterator (void)
| Get an iterator over all the poses defined.
ConstPoseIterator | getPoseIterator (void) const
| Get an iterator over all the poses defined.
const PoseList & | getPoseList (void) const
| Get pose list.
virtual void | prepare ()
| Prepares the resource for load, if it is not already.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual const String & | getName (void) const
| Gets resource name.
virtual ResourceHandle | getHandle (void) const
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
virtual LoadingState | getLoadingState () const
| Returns the current loading state.
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
virtual const String & | getGroup (void)
| Gets the group which this resource is a member of.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
virtual void | _fireBackgroundPreparingComplete (void)
| Firing of background preparing complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | prepareMatricesForVertexBlend (const Matrix4 **blendMatrices, const Matrix4 *boneMatrices, const IndexMap &indexMap)
| Prepare matrices for software indexed vertex blend.
static void | softwareVertexBlend (const VertexData *sourceVertexData, const VertexData *targetVertexData, const Matrix4 *const *blendMatrices, size_t numMatrices, bool blendNormals)
| Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.
static void | softwareVertexMorph (Real t, const HardwareVertexBufferSharedPtr &b1, const HardwareVertexBufferSharedPtr &b2, VertexData *targetVertexData)
| Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.
static void | softwareVertexPoseBlend (Real weight, const std::map< size_t, Vector3 > &vertexOffsetMap, VertexData *targetVertexData)
| Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Public Attributes
VertexData * | sharedVertexData
| Shared vertex data.
IndexMap | sharedBlendIndexToBoneIndexMap
| Shared index map for translating blend index to bone index.
## Protected Types
typedef std::vector< MeshLodUsage > | MeshLodUsageList
typedef std::map< String, Animation * > | AnimationList
| Storage of morph animations, lookup by name.
typedef std::list< Listener * > | ListenerList
## Protected Member Functions
void | organiseTangentsBuffer (VertexData *vertexData, VertexElementSemantic targetSemantic, unsigned short index, unsigned short sourceTexCoordSet)
| Internal method for making the space for a vertex element to hold tangents.
void | buildIndexMap (const VertexBoneAssignmentList &boneAssignments, IndexMap &boneIndexToBlendIndexMap, IndexMap &blendIndexToBoneIndexMap)
| Build the index map between bone index and blend index.
void | compileBoneAssignments (const VertexBoneAssignmentList &boneAssignments, unsigned short numBlendWeightsPerVertex, IndexMap &blendIndexToBoneIndexMap, VertexData *targetVertexData)
| Compile bone assignments into blend index and weight buffers.
void | prepareImpl (void)
| Loads the mesh from disk.
void | unprepareImpl (void)
| Destroys data cached by prepareImpl.
void | loadImpl (void)
| Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.
void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded. Note: Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)
void | unloadImpl (void)
| Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.
size_t | calculateSize (void) const
| Calculate the size of a resource; this will only be called after 'load'.
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
virtual void | queueFireBackgroundPreparingComplete (void)
| Queue the firing of background preparing complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
SubMeshList | mSubMeshList
| A list of submeshes which make up this mesh.
DataStreamPtr | mFreshFromDisk
SubMeshNameMap | mSubMeshNameMap
AxisAlignedBox | mAABB
| Local bounding box volume.
Real | mBoundRadius
| Local bounding sphere radius (centered on object).
String | mSkeletonName
| Optional linked skeleton.
SkeletonPtr | mSkeleton
VertexBoneAssignmentList | mBoneAssignments
bool | mBoneAssignmentsOutOfDate
| Flag indicating that bone assignments need to be recompiled.
bool | mIsLodManual
ushort | mNumLods
MeshLodUsageList | mMeshLodUsageList
HardwareBuffer::Usage | mVertexBufferUsage
HardwareBuffer::Usage | mIndexBufferUsage
bool | mVertexBufferShadowBuffer
bool | mIndexBufferShadowBuffer
bool | mPreparedForShadowVolumes
bool | mEdgeListsBuilt
bool | mAutoBuildEdgeLists
AnimationList | mAnimationsList
VertexAnimationType | mSharedVertexDataAnimationType
| The vertex animation type associated with the shared vertex data.
bool | mAnimationTypesDirty
| Do we need to scan animations for animation types?
PoseList | mPoseList
| List of available poses for shared and dedicated geometryPoseList.
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
AtomicScalar< LoadingState > | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
size_t | mStateCount
| State count, the number of times this resource has changed state.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
## Static Protected Attributes
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.
## Friends
class | SubMesh
class | MeshSerializerImpl
class | MeshSerializerImpl_v1_2
class | MeshSerializerImpl_v1_1

## Detailed Description

Definition at line 86 of file OgreMesh.h.

## Member Typedef Documentation

typedef std::vector<Real> Ogre::Mesh::LodDistanceList

Definition at line 94 of file OgreMesh.h.

typedef std::multimap<size_t, VertexBoneAssignment> Ogre::Mesh::VertexBoneAssignmentList

Multimap of vertex bone assignments (orders by vertex index).

Definition at line 96 of file OgreMesh.h.

typedef MapIterator<VertexBoneAssignmentList> Ogre::Mesh::BoneAssignmentIterator

Definition at line 97 of file OgreMesh.h.

typedef std::vector<SubMesh*> Ogre::Mesh::SubMeshList

Definition at line 98 of file OgreMesh.h.

typedef std::vector<unsigned short> Ogre::Mesh::IndexMap

Definition at line 99 of file OgreMesh.h.

typedef HashMap<String, ushort> Ogre::Mesh::SubMeshNameMap

A hashmap used to store optional SubMesh names.

Translates a name into SubMesh index

Definition at line 119 of file OgreMesh.h.

typedef std::vector<MeshLodUsage> Ogre::Mesh::MeshLodUsageList`[protected]`

Definition at line 154 of file OgreMesh.h.

typedef std::map<String, Animation*> Ogre::Mesh::AnimationList`[protected]`

Storage of morph animations, lookup by name.

Definition at line 168 of file OgreMesh.h.

typedef VectorIterator<SubMeshList> Ogre::Mesh::SubMeshIterator

Definition at line 246 of file OgreMesh.h.

typedef VectorIterator<PoseList> Ogre::Mesh::PoseIterator

Definition at line 849 of file OgreMesh.h.

typedef ConstVectorIterator<PoseList> Ogre::Mesh::ConstPoseIterator

Definition at line 850 of file OgreMesh.h.

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected, inherited]`

Definition at line 148 of file OgreResource.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumerator:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.
  LOADSTATE_PREPARED | Fully prepared.
  LOADSTATE_PREPARING | Preparing is in progress.

Definition at line 109 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Mesh::Mesh | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0` |
| ) |  |  |

Default constructor - used by MeshManager.

Warning:
  Do not call this method directly.

Ogre::Mesh::~Mesh | ( |  | ) |

## Member Function Documentation

void Ogre::Mesh::organiseTangentsBuffer | ( | VertexData * | vertexData,
|  | VertexElementSemantic | targetSemantic,
|  | unsigned short | index,
|  | unsigned short | sourceTexCoordSet |
| ) |  |  | `[protected]`

Internal method for making the space for a vertex element to hold tangents.

void Ogre::Mesh::buildIndexMap | ( | const VertexBoneAssignmentList & | boneAssignments,
|  | IndexMap & | boneIndexToBlendIndexMap,
|  | IndexMap & | blendIndexToBoneIndexMap |
| ) |  |  | `[protected]`

Build the index map between bone index and blend index.

void Ogre::Mesh::compileBoneAssignments | ( | const VertexBoneAssignmentList & | boneAssignments,
|  | unsigned short | numBlendWeightsPerVertex,
|  | IndexMap & | blendIndexToBoneIndexMap,
|  | VertexData * | targetVertexData |
| ) |  |  | `[protected]`

Compile bone assignments into blend index and weight buffers.

void Ogre::Mesh::prepareImpl | ( | void |  | ) | `[protected, virtual]`

Loads the mesh from disk.

This call only performs IO, it does not parse the bytestream or check for any errors therein. It also does not set up submeshes, etc. You have to call load() to do that.

Reimplemented from Ogre::Resource.

Reimplemented in Ogre::PatchMesh.

void Ogre::Mesh::unprepareImpl | ( | void |  | ) | `[protected, virtual]`

Destroys data cached by prepareImpl.

Reimplemented from Ogre::Resource.

void Ogre::Mesh::loadImpl | ( | void |  | ) | `[protected, virtual]`

Internal implementation of the meat of the 'load' action, only called if this resource is not being loaded from a ManualResourceLoader.

Implements Ogre::Resource.

Reimplemented in Ogre::PatchMesh.

void Ogre::Mesh::postLoadImpl | ( | void |  | ) | `[protected, virtual]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented from Ogre::Resource.

void Ogre::Mesh::unloadImpl | ( | void |  | ) | `[protected, virtual]`

Internal implementation of the 'unload' action; called regardless of whether this resource is being loaded from a ManualResourceLoader.

Implements Ogre::Resource.

size_t Ogre::Mesh::calculateSize | ( | void |  | ) | const`[protected, virtual]`

Calculate the size of a resource; this will only be called after 'load'.

Implements Ogre::Resource.

SubMesh* Ogre::Mesh::createSubMesh | ( | void |  | ) |

Creates a new SubMesh.

Remarks:
  Method for manually creating geometry for the mesh. Note - use with extreme caution - you must be sure that you have set up the geometry properly.

SubMesh* Ogre::Mesh::createSubMesh | ( | const String & | name | ) |

Creates a new SubMesh and gives it a name.

void Ogre::Mesh::nameSubMesh | ( | const String & | name,
|  | ushort | index |
| ) |  |  |

Gives a name to a SubMesh.

ushort Ogre::Mesh::_getSubMeshIndex | ( | const String & | name | ) | const

Gets the index of a submesh with a given name.

Remarks:
  Useful if you identify the SubMeshes by name (using nameSubMesh) but wish to have faster repeat access.

unsigned short Ogre::Mesh::getNumSubMeshes | ( | void |  | ) | const

Gets the number of sub meshes which comprise this mesh.

SubMesh* Ogre::Mesh::getSubMesh | ( | unsigned short | index | ) | const

Gets a pointer to the submesh indicated by the index.

SubMesh* Ogre::Mesh::getSubMesh | ( | const String & | name | ) | const

Gets a SubMesh by name.

SubMeshIterator Ogre::Mesh::getSubMeshIterator | ( | void |  | ) |

Gets an iterator over the available submeshes.

Definition at line 248 of file OgreMesh.h.

MeshPtr Ogre::Mesh::clone | ( | const String & | newName,
|  | const String & | newGroup = `StringUtil::BLANK` |
| ) |  |  |

Makes a copy of this mesh object and gives it a new name.

Remarks:
  This is useful if you want to tweak an existing mesh without affecting the original one. The newly cloned mesh is registered with the MeshManager under the new name.

Parameters:

  | newName | The name to give the clone
  | newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Mesh.

const AxisAlignedBox& Ogre::Mesh::getBounds | ( | void |  | ) | const

Get the axis-aligned bounding box for this mesh.

Real Ogre::Mesh::getBoundingSphereRadius | ( | void |  | ) | const

Gets the radius of the bounding sphere surrounding this mesh.

void Ogre::Mesh::_setBounds | ( | const AxisAlignedBox & | bounds,
|  | bool | pad = `true` |
| ) |  |  |

Manually set the bounding box for this Mesh.

Remarks:
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

Parameters:

  | pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

void Ogre::Mesh::_setBoundingSphereRadius | ( | Real | radius | ) |

Manually set the bounding radius.

Remarks:
  Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

void Ogre::Mesh::setSkeletonName | ( | const String & | skelName | ) |

Sets the name of the skeleton this Mesh uses for animation.

Remarks:
  Meshes can optionally be assigned a skeleton which can be used to animate the mesh through bone assignments. The default is for the Mesh to use no skeleton. Calling this method with a valid skeleton filename will cause the skeleton to be loaded if it is not already (a single skeleton can be shared by many Mesh objects).

Parameters:

  | skelName | The name of the .skeleton file to use, or an empty string to use no skeleton

bool Ogre::Mesh::hasSkeleton | ( | void |  | ) | const

Returns true if this Mesh has a linked Skeleton.

bool Ogre::Mesh::hasVertexAnimation | ( | void |  | ) | const

Returns whether or not this mesh has some kind of vertex animation.

const SkeletonPtr& Ogre::Mesh::getSkeleton | ( | void |  | ) | const

Gets a pointer to any linked Skeleton.

Returns:
  Weak reference to the skeleton - copy this if you want to hold a strong pointer.

const String& Ogre::Mesh::getSkeletonName | ( | void |  | ) | const

Gets the name of any linked Skeleton.

void Ogre::Mesh::_initAnimationState | ( | AnimationStateSet * | animSet | ) |

Initialise an animation set suitable for use with this mesh.

Remarks:
  Only recommended for use inside the engine, not by applications.

void Ogre::Mesh::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |

Refresh an animation set suitable for use with this mesh.

Remarks:
  Only recommended for use inside the engine, not by applications.

void Ogre::Mesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |

Assigns a vertex to a bone with a given weight, for skeletal animation.

Remarks:
  This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

void Ogre::Mesh::clearBoneAssignments | ( | void |  | ) |

Removes all bone assignments for this mesh.

Remarks:
  This method is for modifying weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

void Ogre::Mesh::_notifySkeleton | ( | SkeletonPtr & | pSkel | ) |

Internal notification, used to tell the Mesh which Skeleton to use without loading it.

Remarks:
  This is only here for unusual situation where you want to manually set up a Skeleton. Best to let OGRE deal with this, don't call it yourself unless you really know what you're doing.

BoneAssignmentIterator Ogre::Mesh::getBoneAssignmentIterator | ( | void |  | ) |

Gets an iterator for access all bone assignments.

const VertexBoneAssignmentList& Ogre::Mesh::getBoneAssignments | ( |  | ) | const

Gets a const reference to the list of bone assignments.

Definition at line 393 of file OgreMesh.h.

void Ogre::Mesh::generateLodLevels | ( | const LodDistanceList & | lodDistances,
|  | ProgressiveMesh::VertexReductionQuota | reductionMethod,
|  | Real | reductionValue |
| ) |  |  |

Automatically generates lower level of detail versions of this mesh for use when a simpler version of the model is acceptable for rendering.

Remarks:
  There are 2 ways that you can create level-of-detail (LOD) versions of a mesh; the first is to call this method, which does fairly extensive calculations to work out how to simplify the mesh whilst having the minimum affect on the model. The alternative is to actually create simpler versions of the mesh yourself in a modelling tool, and having exported them, tell the 'master' mesh to use these alternative meshes for lower detail versions; this is done by calling the createManualLodLevel method.

  As well as creating the lower detail versions of the mesh, this method will also associate them with depth values. As soon as an object is at least as far away from the camera as the depth value associated with it's LOD, it will drop to that level of detail.

  I recommend calling this method before mesh export, not at runtime.

Parameters:

  | lodDistances | A list of depth values indicating the distances at which new lods should be generated.
  | reductionMethod | The way to determine the number of vertices collapsed per LOD
  | reductionValue | Meaning depends on reductionMethod, typically either the proportion of remaining vertices to collapse or a fixed number of vertices.

ushort Ogre::Mesh::getNumLodLevels | ( | void |  | ) | const

Returns the number of levels of detail that this mesh supports.

Remarks:
  This number includes the original model.

const MeshLodUsage& Ogre::Mesh::getLodLevel | ( | ushort | index | ) | const

Gets details of the numbered level of detail entry.

void Ogre::Mesh::createManualLodLevel | ( | Real | fromDepth,
|  | const String & | meshName |
| ) |  |  |

Adds a new manual level-of-detail entry to this Mesh.

Remarks:
  As an alternative to generating lower level of detail versions of a mesh, you can use your own manually modelled meshes as lower level versions. This lets you have complete control over the LOD, and in addition lets you scale down other aspects of the model which cannot be done using the generated method; for example, you could use less detailed materials and / or use less bones in the skeleton if this is an animated mesh. Therefore for complex models you are likely to be better off modelling your LODs yourself and using this method, whilst for models with fairly simple materials and no animation you can just use the generateLodLevels method.

Parameters:

  | fromDepth | The z value from which this Lod will apply.
  | meshName | The name of the mesh which will be the lower level detail version.

void Ogre::Mesh::updateManualLodLevel | ( | ushort | index,
|  | const String & | meshName |
| ) |  |  |

Changes the alternate mesh to use as a manual LOD at the given index.

Remarks:
  Note that the index of a LOD may change if you insert other LODs. If in doubt, use getLodIndex().

Parameters:

  | index | The index of the level to be changed
  | meshName | The name of the mesh which will be the lower level detail version.

ushort Ogre::Mesh::getLodIndex | ( | Real | depth | ) | const

Retrieves the level of detail index for the given depth value.

ushort Ogre::Mesh::getLodIndexSquaredDepth | ( | Real | squaredDepth | ) | const

Retrieves the level of detail index for the given squared depth value.

Remarks:
  Internally the lods are stored at squared depths to avoid having to perform square roots when determining the lod. This method allows you to provide a squared length depth value to avoid having to do your own square roots.

bool Ogre::Mesh::isLodManual | ( | void |  | ) | const

Returns true if this mesh is using manual LOD.

Remarks:
  A mesh can either use automatically generated LOD, or it can use alternative meshes as provided by an artist. A mesh can only use either all manual LODs or all generated LODs, not a mixture of both.

Definition at line 471 of file OgreMesh.h.

void Ogre::Mesh::_setLodInfo | ( | unsigned short | numLevels,
|  | bool | isManual |
| ) |  |  |

Internal methods for loading LOD, do not use.

void Ogre::Mesh::_setLodUsage | ( | unsigned short | level,
|  | MeshLodUsage & | usage |
| ) |  |  |

Internal methods for loading LOD, do not use.

void Ogre::Mesh::_setSubMeshLodFaceList | ( | unsigned short | subIdx,
|  | unsigned short | level,
|  | IndexData * | facedata |
| ) |  |  |

Internal methods for loading LOD, do not use.

void Ogre::Mesh::removeLodLevels | ( | void |  | ) |

Removes all LOD data from this Mesh.

void Ogre::Mesh::setVertexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false` |
| ) |  |  |

Sets the policy for the vertex buffers to be used when loading this Mesh.

Remarks:
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters:

  | usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  | shadowBuffer | If set to true, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

void Ogre::Mesh::setIndexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = `false` |
| ) |  |  |

Sets the policy for the index buffers to be used when loading this Mesh.

Remarks:
  By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method. Note, however, that it only takes effect after the Mesh has been reloaded. Note that you still have the option of manually repacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

  You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters:

  | usage | The usage flags, which by default are HardwareBuffer::HBU_STATIC_WRITE_ONLY
  | shadowBuffer | If set to true, the index buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer, because reading from a hardware buffer is a no-no.

HardwareBuffer::Usage Ogre::Mesh::getVertexBufferUsage | ( | void |  | ) | const

Gets the usage setting for this meshes vertex buffers.

Definition at line 530 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::getIndexBufferUsage | ( | void |  | ) | const

Gets the usage setting for this meshes index buffers.

Definition at line 532 of file OgreMesh.h.

bool Ogre::Mesh::isVertexBufferShadowed | ( | void |  | ) | const

Gets whether or not this meshes vertex buffers are shadowed.

Definition at line 534 of file OgreMesh.h.

bool Ogre::Mesh::isIndexBufferShadowed | ( | void |  | ) | const

Gets whether or not this meshes index buffers are shadowed.

Definition at line 536 of file OgreMesh.h.

unsigned short Ogre::Mesh::_rationaliseBoneAssignments | ( | size_t | vertexCount,
|  | VertexBoneAssignmentList & | assignments |
| ) |  |  |

Rationalises the passed in bone assignment list.

Remarks:
  OGRE supports up to 4 bone assignments per vertex. The reason for this limit is that this is the maximum number of assignments that can be passed into a hardware-assisted blending algorithm. This method identifies where there are more than 4 bone assignments for a given vertex, and eliminates the bone assignments with the lowest weights to reduce to this limit. The remaining weights are then re-balanced to ensure that they sum to 1.0.

Parameters:

  | vertexCount | The number of vertices.
  | assignments | The bone assignment list to rationalise. This list will be modified and entries will be removed where the limits are exceeded.

Returns:
  The maximum number of bone assignments per vertex found, clamped to [1-4]

void Ogre::Mesh::_compileBoneAssignments | ( | void |  | ) |

Internal method, be called once to compile bone assignments into geometry buffer.

Remarks:
  The OGRE engine calls this method automatically. It compiles the information submitted as bone assignments into a format usable in realtime. It also eliminates excessive bone assignments (max is OGRE_MAX_BLEND_WEIGHTS) and re-normalises the remaining assignments.

void Ogre::Mesh::_updateCompiledBoneAssignments | ( | void |  | ) |

Internal method, be called once to update the compiled bone assignments.

Remarks:
  The OGRE engine calls this method automatically. It updates the compiled bone assignments if requested.

void Ogre::Mesh::buildTangentVectors | ( | VertexElementSemantic | targetSemantic = `VES_TANGENT`,
|  | unsigned short | sourceTexCoordSet = `0`,
|  | unsigned short | index = `0`,
|  | bool | splitMirrored = `false`,
|  | bool | splitRotated = `false`,
|  | bool | storeParityInW = `false` |
| ) |  |  |

This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.

Remarks:
  Tangent vectors are vectors representing the local 'X' axis for a given vertex based on the orientation of the 2D texture on the geometry. They are built from a combination of existing normals, and from the 2D texture coordinates already baked into the model. They can be used for a number of things, but most of all they are useful for vertex and fragment programs, when you wish to arrive at a common space for doing per-pixel calculations.

  The prerequisites for calling this method include that the vertex data used by every SubMesh has both vertex normals and 2D texture coordinates.

Parameters:

  | targetSemantic | The semantic to store the tangents in. Defaults to the explicit tangent binding, but note that this is only usable on more modern hardware (Shader Model 2), so if you need portability with older cards you should change this to a texture coordinate binding instead.
  | sourceTexCoordSet | The texture coordinate index which should be used as the source of 2D texture coordinates, with which to calculate the tangents.
  | index | The element index, ie the texture coordinate set which should be used to store the 3D coordinates representing a tangent vector per vertex, if targetSemantic is VES_TEXTURE_COORDINATES. If this already exists, it will be overwritten.
  | splitMirrored | Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs).

See also:
  TangentSpaceCalc::setSplitMirrored

Parameters:

  | splitRotated | Sets whether or not to split vertices when a rotated tangent space is detected.

See also:
  TangentSpaceCalc::setSplitRotated

Parameters:

  | storeParityInW | If true, store tangents as a 4-vector and include parity in w

bool Ogre::Mesh::suggestTangentVectorBuildParams | ( | VertexElementSemantic | targetSemantic,
|  | unsigned short & | outSourceCoordSet,
|  | unsigned short & | outIndex |
| ) |  |  |

Ask the mesh to suggest parameters to a future buildTangentVectors call, should you wish to use texture coordinates to store the tangents.

Remarks:
  This helper method will suggest source and destination texture coordinate sets for a call to buildTangentVectors. It will detect when there are inappropriate conditions (such as multiple geometry sets which don't agree). Moreover, it will return 'true' if it detects that there are aleady 3D coordinates in the mesh, and therefore tangents may have been prepared already.

Parameters:

  | targetSemantic | The semantic you intend to use to store the tangents if they are not already present; most likely options are VES_TEXTURE_COORDINATES or VES_TANGENT; you should use texture coordinates if you want compatibility with older, pre-SM2 graphics cards, and the tangent binding otherwise.
  | outSourceCoordSet | Reference to a source texture coordinate set which will be populated
  | outIndex | Reference to a destination element index (e.g. texture coord set) which will be populated

void Ogre::Mesh::buildEdgeList | ( | void |  | ) |

Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.

void Ogre::Mesh::freeEdgeList | ( | void |  | ) |

Destroys and frees the edge lists this mesh has built.

void Ogre::Mesh::prepareForShadowVolume | ( | void |  | ) |

This method prepares the mesh for generating a renderable shadow volume.

Remarks:
  Preparing a mesh to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions for the mesh is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers this mesh holds if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version of the mesh. The vertex count of the main VertexData used to render the mesh will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version.

  Because shadow volumes are rendered in turn, no additional index buffer space is allocated by this method, a shared index buffer allocated by the shadow rendering algorithm is used for addressing this extended vertex buffer.

EdgeData* Ogre::Mesh::getEdgeList | ( | unsigned int | lodIndex = `0` | ) |

Return the edge list for this mesh, building it if required.

Remarks:
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose. The LOD at which to get the edge list, 0 being the highest.

const EdgeData* Ogre::Mesh::getEdgeList | ( | unsigned int | lodIndex = `0` | ) | const

Return the edge list for this mesh, building it if required.

Remarks:
  You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose. The LOD at which to get the edge list, 0 being the highest.

bool Ogre::Mesh::isPreparedForShadowVolumes | ( | void |  | ) | const

Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.

Definition at line 666 of file OgreMesh.h.

bool Ogre::Mesh::isEdgeListBuilt | ( | void |  | ) | const

Returns whether this mesh has an attached edge list.

Definition at line 669 of file OgreMesh.h.

static void Ogre::Mesh::prepareMatricesForVertexBlend | ( | const Matrix4 ** | blendMatrices,
|  | const Matrix4 * | boneMatrices,
|  | const IndexMap & | indexMap |
| ) |  |  | `[static]`

Prepare matrices for software indexed vertex blend.

Remarks:
  This function organise bone indexed matrices to blend indexed matrices, so software vertex blending can access to the matrix via blend index directly.

Parameters:

  | blendMatrices | Pointer to an array of matrix pointers to store prepared results, which indexed by blend index
  | boneMatrices | Pointer to an array of matrices to be used to blend, which indexed by bone index
  | indexMap | The index map used to translate blend index to bone index

static void Ogre::Mesh::softwareVertexBlend | ( | const VertexData * | sourceVertexData,
|  | const VertexData * | targetVertexData,
|  | const Matrix4 *const * | blendMatrices,
|  | size_t | numMatrices,
|  | bool | blendNormals |
| ) |  |  | `[static]`

Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.

Remarks:
  This function is supplied to update vertex data with blends done in software, either because no hardware support is available, or that you need the results of the blend for some other CPU operations.

Parameters:

  | sourceVertexData | VertexData class containing positions, normals, blend indices and blend weights.
  | targetVertexData | VertexData class containing target position and normal buffers which will be updated with the blended versions. Note that the layout of the source and target position / normal buffers must be identical, ie they must use the same buffer indexes
  | blendMatrices | Pointer to an array of matrix pointers to be used to blend, indexed by blend indices in the sourceVertexData
  | numMatrices | Number of matrices in the blendMatrices, it might be used as a hint for optimisation.
  | blendNormals | If true, normals are blended as well as positions

static void Ogre::Mesh::softwareVertexMorph | ( | Real | t,
|  | const HardwareVertexBufferSharedPtr & | b1,
|  | const HardwareVertexBufferSharedPtr & | b2,
|  | VertexData * | targetVertexData |
| ) |  |  | `[static]`

Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.

Remarks:
  This function will linearly interpolate positions between two source buffers, into a third buffer.

Parameters:

  | t | Parametric distance between the start and end buffer positions
  | b1 | Vertex buffer containing VET_FLOAT3 entries for the start positions
  | b2 | Vertex buffer containing VET_FLOAT3 entries for the end positions
  | targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

static void Ogre::Mesh::softwareVertexPoseBlend | ( | Real | weight,
|  | const std::map< size_t, Vector3 > & | vertexOffsetMap,
|  | VertexData * | targetVertexData |
| ) |  |  | `[static]`

Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.

Remarks:
  This function will apply a weighted offset to the positions in the incoming vertex data (therefore this is a read/write operation, and if you expect to call it more than once with the same data, then you would be best to suppress hardware uploads of the position buffer for the duration)

Parameters:

  | weight | Parametric weight to scale the offsets by
  | vertexOffsetMap | Potentially sparse map of vertex index -> offset
  | targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

const SubMeshNameMap& Ogre::Mesh::getSubMeshNameMap | ( | void |  | ) | const

Gets a reference to the optional name assignments of the SubMeshes.

Definition at line 743 of file OgreMesh.h.

void Ogre::Mesh::setAutoBuildEdgeLists | ( | bool | autobuild | ) |

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

Remarks:
  This allows you to create meshes which do not have edge lists calculated, because you never want to use them. This value defaults to 'true' for mesh formats which did not include edge data, and 'false' for newer formats, where edge lists are expected to have been generated in advance.

Definition at line 755 of file OgreMesh.h.

bool Ogre::Mesh::getAutoBuildEdgeLists | ( | void |  | ) | const

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

Definition at line 760 of file OgreMesh.h.

virtual VertexAnimationType Ogre::Mesh::getSharedVertexDataAnimationType | ( | void |  | ) | const`[virtual]`

Gets the type of vertex animation the shared vertex data of this mesh supports.

virtual Animation* Ogre::Mesh::createAnimation | ( | const String & | name,
|  | Real | length |
| ) |  |  | `[virtual]`

Creates a new Animation object for vertex animating this mesh.

Parameters:

  | name | The name of this animation
  | length | The length of the animation in seconds

virtual Animation* Ogre::Mesh::getAnimation | ( | const String & | name | ) | const`[virtual]`

Returns the named vertex Animation object.

Parameters:

  | name | The name of the animation

virtual Animation* Ogre::Mesh::_getAnimationImpl | ( | const String & | name | ) | const`[virtual]`

Internal access to the named vertex Animation object - returns null if it does not exist.

Parameters:

  | name | The name of the animation

virtual bool Ogre::Mesh::hasAnimation | ( | const String & | name | ) | `[virtual]`

Returns whether this mesh contains the named vertex animation.

virtual void Ogre::Mesh::removeAnimation | ( | const String & | name | ) | `[virtual]`

Removes vertex Animation from this mesh.

virtual unsigned short Ogre::Mesh::getNumAnimations | ( | void |  | ) | const`[virtual]`

Gets the number of morph animations in this mesh.

virtual Animation* Ogre::Mesh::getAnimation | ( | unsigned short | index | ) | const`[virtual]`

Gets a single morph animation by index.

virtual void Ogre::Mesh::removeAllAnimations | ( | void |  | ) | `[virtual]`

Removes all morph Animations from this mesh.

VertexData* Ogre::Mesh::getVertexDataByTrackHandle | ( | unsigned short | handle | ) |

Gets a pointer to a vertex data element based on a morph animation track handle.

Remarks:
  0 means the shared vertex data, 1+ means a submesh vertex data (index+1)

void Ogre::Mesh::updateMaterialForAllSubMeshes | ( | void |  | ) |

Iterates through all submeshes and requests them to apply their texture aliases to the material they use.

Remarks:
  The submesh will only apply texture aliases to the material if matching texture alias names are found in the material. If a match is found, the submesh will automatically clone the original material and then apply its texture to the new material.

  This method is normally called by the protected method loadImpl when a mesh if first loaded.

void Ogre::Mesh::_determineAnimationTypes | ( | void |  | ) | const

Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).

bool Ogre::Mesh::_getAnimationTypesDirty | ( | void |  | ) | const

Are the derived animation types out of date?

Definition at line 823 of file OgreMesh.h.

Pose* Ogre::Mesh::createPose | ( | ushort | target,
|  | const String & | name = `StringUtil::BLANK` |
| ) |  |  |

Create a new Pose for this mesh or one of its submeshes.

Parameters:

  | target | The target geometry index; 0 is the shared Mesh geometry, 1+ is the dedicated SubMesh geometry belonging to submesh index + 1.
  | name | Name to give the pose, which is optional

Returns:
  A new Pose ready for population

size_t Ogre::Mesh::getPoseCount | ( | void |  | ) | const

Get the number of poses.

Definition at line 833 of file OgreMesh.h.

Pose* Ogre::Mesh::getPose | ( | ushort | index | ) |

Retrieve an existing Pose by index.

Pose* Ogre::Mesh::getPose | ( | const String & | name | ) |

Retrieve an existing Pose by name.

void Ogre::Mesh::removePose | ( | ushort | index | ) |

Destroy a pose by index.

Note:
  This will invalidate any animation tracks referring to this pose or those after it.

void Ogre::Mesh::removePose | ( | const String & | name | ) |

Destroy a pose by name.

Note:
  This will invalidate any animation tracks referring to this pose or those after it.

void Ogre::Mesh::removeAllPoses | ( | void |  | ) |

Destroy all poses.

PoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) |

Get an iterator over all the poses defined.

ConstPoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) | const

Get an iterator over all the poses defined.

const PoseList& Ogre::Mesh::getPoseList | ( | void |  | ) | const

Get pose list.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 178 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 183 of file OgreResource.h.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

Queue the firing of background loading complete event.

virtual void Ogre::Resource::queueFireBackgroundPreparingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

Queue the firing of background preparing complete event.

virtual void Ogre::Resource::prepare | ( |  | ) | `[virtual, inherited]`

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 271 of file OgreResource.h.

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[virtual, inherited]`

Is this resource manually loaded?

Definition at line 278 of file OgreResource.h.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const`[virtual, inherited]`

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 290 of file OgreResource.h.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

Referenced by Ogre::Material::touch().

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const`[virtual, inherited]`

Gets resource name.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 301 of file OgreResource.h.

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[virtual, inherited]`

Reimplemented in Ogre::SkeletonInstance.

Definition at line 306 of file OgreResource.h.

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been prepared, false otherwise.

Definition at line 313 of file OgreResource.h.

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 321 of file OgreResource.h.

virtual bool Ogre::Resource::isLoading | ( |  | ) | const`[virtual, inherited]`

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 330 of file OgreResource.h.

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[virtual, inherited]`

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 337 of file OgreResource.h.

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[virtual, inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 354 of file OgreResource.h.

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[virtual, inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 364 of file OgreResource.h.

virtual void Ogre::Resource::escalateLoading | ( |  | ) | `[virtual, inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[virtual, inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | `[virtual, inherited]`

Gets the group which this resource is a member of.

Reimplemented in Ogre::SkeletonInstance.

Definition at line 388 of file OgreResource.h.

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[virtual, inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[virtual, inherited]`

Gets the manager which created this resource.

Definition at line 400 of file OgreResource.h.

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[virtual, inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 407 of file OgreResource.h.

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[virtual, inherited]`

Notify this resource of it's origin.

Definition at line 409 of file OgreResource.h.

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const`[virtual, inherited]`

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

Definition at line 418 of file OgreResource.h.

virtual void Ogre::Resource::_dirtyState | ( |  | ) | `[virtual, inherited]`

Manually mark the state of this resource as having been changed.

Remarks:
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also:
  getStateCount.

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of background loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

virtual void Ogre::Resource::_fireBackgroundPreparingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of background preparing complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 213 of file OgreStringInterface.h.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Friends And Related Function Documentation

friend class SubMesh`[friend]`

Definition at line 88 of file OgreMesh.h.

friend class MeshSerializerImpl`[friend]`

Definition at line 89 of file OgreMesh.h.

friend class MeshSerializerImpl_v1_2`[friend]`

Definition at line 90 of file OgreMesh.h.

friend class MeshSerializerImpl_v1_1`[friend]`

Definition at line 91 of file OgreMesh.h.

## Member Data Documentation

SubMeshList Ogre::Mesh::mSubMeshList`[protected]`

A list of submeshes which make up this mesh.

Each mesh is made up of 1 or more submeshes, which are each based on a single material and can have their own vertex data (they may not - they can share vertex data from the Mesh, depending on preference).

Definition at line 108 of file OgreMesh.h.

DataStreamPtr Ogre::Mesh::mFreshFromDisk`[protected]`

Definition at line 124 of file OgreMesh.h.

SubMeshNameMap Ogre::Mesh::mSubMeshNameMap`[protected]`

Definition at line 126 of file OgreMesh.h.

AxisAlignedBox Ogre::Mesh::mAABB`[protected]`

Local bounding box volume.

Definition at line 129 of file OgreMesh.h.

Real Ogre::Mesh::mBoundRadius`[protected]`

Local bounding sphere radius (centered on object).

Definition at line 131 of file OgreMesh.h.

String Ogre::Mesh::mSkeletonName`[protected]`

Optional linked skeleton.

Definition at line 134 of file OgreMesh.h.

SkeletonPtr Ogre::Mesh::mSkeleton`[protected]`

Definition at line 135 of file OgreMesh.h.

VertexBoneAssignmentList Ogre::Mesh::mBoneAssignments`[protected]`

Definition at line 138 of file OgreMesh.h.

bool Ogre::Mesh::mBoneAssignmentsOutOfDate`[protected]`

Flag indicating that bone assignments need to be recompiled.

Definition at line 141 of file OgreMesh.h.

bool Ogre::Mesh::mIsLodManual`[protected]`

Definition at line 152 of file OgreMesh.h.

ushort Ogre::Mesh::mNumLods`[protected]`

Definition at line 153 of file OgreMesh.h.

MeshLodUsageList Ogre::Mesh::mMeshLodUsageList`[protected]`

Definition at line 155 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::mVertexBufferUsage`[protected]`

Definition at line 157 of file OgreMesh.h.

HardwareBuffer::Usage Ogre::Mesh::mIndexBufferUsage`[protected]`

Definition at line 158 of file OgreMesh.h.

bool Ogre::Mesh::mVertexBufferShadowBuffer`[protected]`

Definition at line 159 of file OgreMesh.h.

bool Ogre::Mesh::mIndexBufferShadowBuffer`[protected]`

Definition at line 160 of file OgreMesh.h.

bool Ogre::Mesh::mPreparedForShadowVolumes`[protected]`

Definition at line 163 of file OgreMesh.h.

bool Ogre::Mesh::mEdgeListsBuilt`[protected]`

Definition at line 164 of file OgreMesh.h.

bool Ogre::Mesh::mAutoBuildEdgeLists`[protected]`

Definition at line 165 of file OgreMesh.h.

AnimationList Ogre::Mesh::mAnimationsList`[protected]`

Definition at line 169 of file OgreMesh.h.

VertexAnimationType Ogre::Mesh::mSharedVertexDataAnimationType`[mutable, protected]`

The vertex animation type associated with the shared vertex data.

Definition at line 171 of file OgreMesh.h.

bool Ogre::Mesh::mAnimationTypesDirty`[mutable, protected]`

Do we need to scan animations for animation types?

Definition at line 173 of file OgreMesh.h.

PoseList Ogre::Mesh::mPoseList`[protected]`

List of available poses for shared and dedicated geometryPoseList.

Definition at line 176 of file OgreMesh.h.

VertexData* Ogre::Mesh::sharedVertexData

Shared vertex data.

Remarks:
  This vertex data can be shared among multiple submeshes. SubMeshes may not have their own VertexData, they may share this one.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

Definition at line 259 of file OgreMesh.h.

IndexMap Ogre::Mesh::sharedBlendIndexToBoneIndexMap

Shared index map for translating blend index to bone index.

Remarks:
  This index map can be shared among multiple submeshes. SubMeshes might not have their own IndexMap, they might share this one.

  We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire Mesh.

  Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index.

  The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format.

Definition at line 281 of file OgreMesh.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

Creator.

Definition at line 126 of file OgreResource.h.

String Ogre::Resource::mName`[protected, inherited]`

Unique name of the resource.

Definition at line 128 of file OgreResource.h.

String Ogre::Resource::mGroup`[protected, inherited]`

The name of the resource group.

Definition at line 130 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

Numeric handle for more efficient look up than name.

Definition at line 132 of file OgreResource.h.

AtomicScalar<LoadingState> Ogre::Resource::mLoadingState`[protected, inherited]`

Is the resource currently loaded?

Definition at line 134 of file OgreResource.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

Is this resource going to be background loaded? Only applicable for multithreaded.

Definition at line 136 of file OgreResource.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

The size of the resource in bytes.

Definition at line 138 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

Is this file manually loaded?

Definition at line 140 of file OgreResource.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

Origin of this resource (e.g. script name) - optional.

Definition at line 142 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

Optional manual loader; if provided, data is loaded from here instead of a file.

Definition at line 144 of file OgreResource.h.

size_t Ogre::Resource::mStateCount`[protected, inherited]`

State count, the number of times this resource has changed state.

Definition at line 146 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

Definition at line 149 of file OgreResource.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

Dictionary of parameters.

Definition at line 161 of file OgreStringInterface.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

Class name for this instance to be used as a lookup (must be initialised by subclasses).

Definition at line 164 of file OgreStringInterface.h.

The documentation for this class was generated from the following file:

- OgreMesh.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:34:06 2009